/*
 * SienaGaugeMgrHandle.java
 *
 * Created on November 5, 2001, 11:36 AM
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.Events.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class SienaGaugeMgrHandle implements edu.cmu.cs.able.gaugeInfrastructure.GaugeMgr {

    static SienaEventBus eventBus = SienaEventBus.theEventBus; 
    public String gaugeMgrID = null;
    
    /** Creates new SienaGaugeMgrHandle */
    public SienaGaugeMgrHandle(String gaugeType) {
        // Find a gauge manager that manages gauge type
        FindGaugeMgrEvent request = new FindGaugeMgrEvent (gaugeType);
        FindGaugeMgrEvent reply = new FindGaugeMgrEvent (gaugeType);
        reply = (FindGaugeMgrEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        
        if (reply.status) {
            gaugeMgrID = reply.gaugeMgrID;
        }
    }
    
    public String getGaugeMgrID () {
        return gaugeMgrID;
    }

    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings) {
        CreateGaugeEvent request = new CreateGaugeEvent (gauge);
        CreateGaugeEvent reply = new CreateGaugeEvent (gauge);
        request.gaugeMgrID = gaugeMgrID;
        reply.gaugeMgrID = gaugeMgrID;
        request.setupParams = setupParams;
        request.mappings = mappings;
        reply = (CreateGaugeEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        
        if (reply.status) {
            SienaGaugeHandle handle = new SienaGaugeHandle (reply);
            return handle;
        }
        else {
            return null;
        }
    }
    
    public boolean deleteGauge(GaugeControl gauge) {
        DeleteGaugeEvent request = new DeleteGaugeEvent (gauge.getGaugeID ());
        DeleteGaugeEvent reply = new DeleteGaugeEvent (gauge.getGaugeID ());
        request.gaugeMgrID = gaugeMgrID;
        reply = (DeleteGaugeEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        
        return reply.status;
    }
    
    public boolean managesType(String gaugeType) {
        return true;
    }
    
    public boolean queryMetaInfo(String gaugeType, StringPairVector configParamsMeta, StringPairVector valuesMeta) {
        QueryMetaInfoEvent request = new QueryMetaInfoEvent (gaugeType);
        QueryMetaInfoEvent reply = new QueryMetaInfoEvent (gaugeType);
        request.gaugeMgrID = gaugeMgrID;
        reply = (QueryMetaInfoEvent )eventBus.publishRequest (request);
        //eventBus.waitForReply (reply);
        if (reply.status) {
            reply.configParams.copyInto (configParamsMeta);
            reply.values.copyInto (valuesMeta);
        }
        return reply.status;
        
    }
}
