/*
 * SienaReportingBus.java
 *
 * Created on November 2, 2001, 7:53 PM
 */

package edu.cmu.cs.able.gaugeInfrastructure.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.Events.*;
import siena.*;
import java.util.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class SienaGaugeReportingBus 
        implements edu.cmu.cs.able.gaugeInfrastructure.GaugeReportingBus, Notifiable {

    public static SienaEventBus sienaBus = null;
    
    public static SienaGaugeReportingBus reportingBus = null;
    
    private GaugeConsumer consumer = null;
    /** Creates new SienaReportingBus */
    public SienaGaugeReportingBus() {
        sienaBus = SienaEventBus.theEventBus;
        reportingBus = this;
    }

    
    public boolean reportConfigured(GaugeID gauge, StringPairVector configParams) {
        ConfiguredEvent event = new ConfiguredEvent (gauge);
        event.configParams = configParams;
        sienaBus.publishAnnouncement (event);
        return true;
    }
    
    public boolean reportCreated(GaugeID gauge) {
        CreatedEvent event = new CreatedEvent (gauge);
        sienaBus.publishAnnouncement (event);
        return true;
    }
    
    public boolean reportMultipleValues(GaugeID gauge, GaugeValueVector values) {
        MultipleValueEvent event = new MultipleValueEvent (gauge);
        event.values = values;
        sienaBus.publishAnnouncement (event);
        return true;
    }
    
    public boolean reportValue(GaugeID gauge, String valueName, String propertyName, String value) {
        ValueEvent event = new ValueEvent (gauge);
        event.valueName = valueName;
        event.propertyName = propertyName;
        event.value = value;
        sienaBus.publishAnnouncement (event);
        return true;
    }
    
    public boolean reportDeleted(GaugeID gauge) {
        DeletedEvent event = null;
        if (gauge instanceof DeletedEvent) {
            event = (DeletedEvent )gauge;
        }
        else event = new DeletedEvent (gauge);
        sienaBus.publishAnnouncement (event);
        return true;
    }
    
    

    
    private class Subscription {
        public Subscriber subscriber;
        public Filter filter;
        
        public Subscription (Filter fp, Subscriber sub) {
            filter = fp;
            subscriber = sub;
        }
    }
    
    Vector subscriptions = new Vector ();
    
    private void registerSubscriber (siena.Filter f, Subscriber sub) {
        Subscription scrp = new Subscription (f, sub);
        subscriptions.addElement (scrp);
    }
    

    
    public void subscribeToGaugeEvent(GaugeEvent event, Subscriber subscriber) {
        Filter f = sienaBus.event2Filter (event);
        
        try {
            sienaBus.siena.subscribe (f, this);
            registerSubscriber (f, subscriber);
        }
        catch (Exception e) {
            e.printStackTrace ();
        }
        
    }
    
    public void unsubscribeToGaugeEvent(GaugeEvent event, Subscriber subscriber) {
        Filter f = sienaBus.event2Filter (event);
        for (int i = 0; i < subscriptions.size (); i++) {
            Subscription scrp = (Subscription )subscriptions.elementAt (i);
            if (scrp.filter.equals (f) && scrp.subscriber.equals (subscriber)) {
                subscriptions.removeElementAt (i);
                sienaBus.siena.unsubscribe (f, this);
                i--;
            }
        }
    }
    
    public void notify (Notification e) {
        for (int i = 0; i < subscriptions.size (); i++) {
            Subscription sub = (Subscription )subscriptions.elementAt (i);
            if (siena.Covering.apply (sub.filter, e)) {
                sub.subscriber.receiveEvent (sienaBus.notification2Event (e));
            }
        }
    }
    
    public void notify (Notification [] e) {
        for (int i = 0; i < e.length; i++) {
            notify (e [i]);
        }
    }
    
    public static GaugeReportingBus getReportingBus() {
        return reportingBus;
 
    }
    
/*    public void registerGaugeConsumer(GaugeConsumer consumer, GaugeControl gauge) {
        if (!(sienaBus.registerDeletedEvents (consumer, gauge) &&
              sienaBus.registerCreatedEvents (consumer, gauge) &&
              sienaBus.registerConfiguredEvents (consumer, gauge) &&
              sienaBus.registerValueEvents (consumer, gauge))) {
            System.err.println ("Could not register for events");         
        }
    }
 */
    
    public void registerGauge (GaugeControl gauge, StringPairVector setupParams, 
                               StringPairVector mappings, boolean waitForInit, String myManagerID) {
 
               sienaBus.registerGauge (gauge); 
        if (waitForInit) {
            Global.debug ("Sending for initialization");
            GaugeInitEvent request = new GaugeInitEvent (gauge.getGaugeID ());
            request.gaugeMgrID = myManagerID;
            request = (GaugeInitEvent )sienaBus.publishRequest (request);
            //sienaBus.waitForReply (request);
            if (!request.status) {
                Global.debug ("Could not get initialization parameters");
            }
            else {
                Global.debug ("Got initialization");
                request.mappings.copyInto (mappings);
                request.setup.copyInto (setupParams);
            }
            
            ((SienaGauge )gauge).setGaugeID (request); 
        }

    }
}
